import 'dart:async';
import 'dart:math';
import 'package:alto_great_circle_distance/src/geo.dart';
import 'package:flutter/services.dart';
export 'package:alto_great_circle_distance/src/geo.dart';

class GCD {
  static const MethodChannel _channel = MethodChannel('great_circle_distance');

  static Future<String?> get platformVersion async {
    final String? version = await _channel.invokeMethod('getPlatformVersion');
    return version;
  }

  // return the distance in km
  Future<double?> cal({
    required Geo geo1,
    required Geo geo2,
  }) async {
    // Great circle distance by Spherical Law of Cosines
    final double _lat1 = _radiansFromDegrees(geo1.lat);
    final double _lat2 = _radiansFromDegrees(geo2.lat);
    final double _aLon = _radiansFromDegrees(geo2.lon - geo1.lon);
    final double _d =
        acos(sin(_lat1) * sin(_lat2) + cos(_lat1) * cos(_lat2) * cos(_aLon));
    return _earthRadius * _d;
  }

  /// [_earthRadius] Radius of the Earch in km.
  final double _earthRadius = 6378.1370;

  double _radiansFromDegrees(final double degrees) => degrees * (pi / 180.0);
}
